Attribute VB_Name = "ModHook"
Option Explicit
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Function VirtualProtect Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flNewProtect As Long, ByRef lpflOldProtect As Long) As Long
Private Const PAGE_EXECUTE_READWRITE As Long = &H40
Private Type TSplicepData
bData(4) As Byte
lAddressOfOrigin As Long
lAddressOfNew As Long
bIsPaused As Boolean
End Type
Private msdHookArray() As TSplicepData
Private mlHooksCount As Long

Public Function HookFunction(ByVal lpSourceAddress As Long, ByVal lpDestinationAddress As Long) As Boolean
Dim lIndex As Long
On Error GoTo CATCH_EXCEPTION
lIndex = GetFreeIndex()
If VirtualProtect(lpSourceAddress, 5, PAGE_EXECUTE_READWRITE, 0) = 0 Then Exit Function
CopyMemory msdHookArray(lIndex).bData(0), ByVal lpSourceAddress, 5
CopyMemory ByVal lpSourceAddress, &HE9, 1
CopyMemory ByVal lpSourceAddress + 1, CLng(lpDestinationAddress - lpSourceAddress - 5), 4
msdHookArray(lIndex).lAddressOfOrigin = lpSourceAddress
msdHookArray(lIndex).lAddressOfNew = lpDestinationAddress
mlHooksCount = mlHooksCount + 1
HookFunction = True
Exit Function
CATCH_EXCEPTION:
End Function

Public Function PauseHook(ByVal pAddress As Long) As Boolean
Dim lIndex As Long
On Error GoTo CATCH_EXCEPTION
lIndex = FindHook(pAddress)
If lIndex < 0 Then Exit Function
If msdHookArray(lIndex).bIsPaused Then Exit Function
CopyMemory ByVal msdHookArray(lIndex).lAddressOfOrigin, msdHookArray(lIndex).bData(0), 5
msdHookArray(lIndex).bIsPaused = True
PauseHook = True
Exit Function
CATCH_EXCEPTION:
End Function

Public Function ResumeHook(ByVal pAddress As Long) As Boolean
Dim lIndex As Long
On Error GoTo CATCH_EXCEPTION
lIndex = FindHook(pAddress)
If lIndex < 0 Then Exit Function
If Not msdHookArray(lIndex).bIsPaused Then Exit Function
CopyMemory ByVal msdHookArray(lIndex).lAddressOfOrigin, &HE9, 1
CopyMemory ByVal msdHookArray(lIndex).lAddressOfOrigin + 1, CLng(msdHookArray(lIndex).lAddressOfNew - msdHookArray(lIndex).lAddressOfOrigin - 5), 4
msdHookArray(lIndex).bIsPaused = False
ResumeHook = True
Exit Function
CATCH_EXCEPTION:
End Function

Public Function UnhookFunction(ByVal pAddress As Long) As Boolean
Dim lIndex As Long
On Error GoTo CATCH_EXCEPTION
lIndex = FindHook(pAddress)
If lIndex < 0 Then Exit Function
CopyMemory ByVal msdHookArray(lIndex).lAddressOfOrigin, msdHookArray(lIndex).bData(0), 5
msdHookArray(lIndex).lAddressOfOrigin = 0
UnhookFunction = True
Exit Function
CATCH_EXCEPTION:
End Function

Private Function GetFreeIndex() As Long
Dim lIndex As Long
For lIndex = 0 To mlHooksCount - 1
    If msdHookArray(lIndex).lAddressOfOrigin = 0 Then
        GetFreeIndex = lIndex
        Exit Function
    End If
Next lIndex
GetFreeIndex = mlHooksCount
ReDim Preserve msdHookArray(mlHooksCount + 10)
End Function

Private Function FindHook(ByVal pAddress As Long) As Long
Dim lIndex As Long
For lIndex = 0 To mlHooksCount - 1
    If msdHookArray(lIndex).lAddressOfOrigin = pAddress Then
        FindHook = lIndex
        Exit Function
    End If
Next lIndex
FindHook = -1
End Function
